#include <stdint.h>
#include <stdio.h>
#include <windows.h>

uint32_t *mod_type;
uint8_t **mod_name;
uint8_t **mod_pref;
uint8_t **mod_vers;
uint8_t **mod_copr;

int main (int argc, char **argv)
{
 int t;
 HMODULE hmodule;
 
 if (argc<2)
 {
  fprintf (stderr, "usage: %s filename.mod [...]\n", argv[0]);
  return -1;
 }
 
 for (t=1;t<argc;t++)
 {
  hmodule=LoadLibrary(argv[t]);
  if (!hmodule)
  {
   fprintf (stderr, "%s: Could not open\n", argv[t]);
   continue;
  }
  mod_type=(void*)GetProcAddress(hmodule,"mod_type");
  mod_name=(void*)GetProcAddress(hmodule,"mod_name");
  mod_pref=(void*)GetProcAddress(hmodule,"mod_pref");
  mod_vers=(void*)GetProcAddress(hmodule,"mod_vers");
  mod_copr=(void*)GetProcAddress(hmodule,"mod_copr");
  if ((!mod_type)||(!mod_name)||(!mod_pref)||(!mod_vers)||(!mod_copr))
  {
   fprintf (stderr, "%s: Is not a MoDapple plugin\n", argv[t]);
  }
  printf ("Module filename:       %s\n"
          "Module type (FOURCC):  %c%c%c%c\n"
          "Module name:           %s\n"
          "Module prefix:         %s\n"
          "Module version:        %s\n"
          "Module copyright:      %s\n", argv[t],
          ((char*)mod_type)[0], ((char*)mod_type)[1], ((char*)mod_type)[2], ((char*)mod_type)[3], 
          *mod_name, *mod_pref, *mod_vers, *mod_copr);
 
  FreeLibrary(hmodule);
 }
 
 return 0;
}